<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00054002ReducaoQuantidadeMedidaPerfilAcessoService;
use SM\Traits\TResponse;

class Sm00054002ReducaoQuantidadeMedidaPerfilAcessoController extends SMCrud
{

    use TResponse;

    protected $reducaoQuantidadeMedidaPerfilAcessoService;

    public function __construct($crudService, $environment, Sm00054002ReducaoQuantidadeMedidaPerfilAcessoService $reducaoQuantidadeMedidaPerfilAcessoService)
    {
            parent::__construct($crudService, $environment);
            $this->reducaoQuantidadeMedidaPerfilAcessoService = $reducaoQuantidadeMedidaPerfilAcessoService;
    }

    public function getReducaoQuantidadeMedidaPerfilAcesso()
    {
        try {
                $data = $this->reducaoQuantidadeMedidaPerfilAcessoService->getReducaoQuantidadeMedidaPerfilAcesso();
                $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirReducaoQuantidadeMedidaPerfilAcesso(DTO\Request $request)
    {
        
        try {
            $this->reducaoQuantidadeMedidaPerfilAcessoService->inserirReducaoQuantidadeMedidaPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deletarReducaoQuantidadeMedidaPerfilAcesso(DTO\Request $request)
    {
        try {
            $this->reducaoQuantidadeMedidaPerfilAcessoService->deletarReducaoQuantidadeMedidaPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
