<?php

namespace SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctCancApuracaoFaturamento {
    
    const NOME = "FCT_CANC_APURCAO_FATURAMENTO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure FCT_CANC_APURCAO_FATURAMENTO.
     * 
     * @param integer $nrorg
     * @param string  $nrseqcontrato
     * @param string  $cdoperinclusao
     * @param string  $dataini
     * @param string  $datafin
     * @param string  $nrfaturacont
     * @param string  $nrrateioitemvenc
     */
     
    public function executar($nrorg, $nrseqcontrato, $cdoperinclusao, $dataini, $datafin, $nrfaturacont, $nrrateioitfatura, $nritfaturacont) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRORG",             Param::PARAM_INPUT,  $nrorg,             Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRSEQCONTRATO",     Param::PARAM_INPUT,  $nrseqcontrato,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_CDOPERINCLUSAO",    Param::PARAM_INPUT,  $cdoperinclusao,    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DATAINI",           Param::PARAM_INPUT,  $dataini,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DATAFIN",           Param::PARAM_INPUT,  $datafin,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRFATURACONT",      Param::PARAM_INPUT,  $nrfaturacont,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRRATEIOITEMVENC",  Param::PARAM_INPUT,  $nrrateioitfatura,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRITFATURACONT",    Param::PARAM_INPUT,  $nritfaturacont,    Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
}

?>
