IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQUIVO_SINTEGRA_50' AND
              TYPE   = 'P' 		 AND
              U.UID  = O.UID             AND
              U.NAME = USER)

DROP PROCEDURE ARQUIVO_SINTEGRA_50
GO

CREATE PROCEDURE ARQUIVO_SINTEGRA_50
   @P_CDEMPRESA        VARCHAR(02),
   @P_CDIMPOSTO        VARCHAR(02),
   @P_CDINSCESTA       VARCHAR(16),
   @P_DTINICIAL        DATETIME,
   @P_DTFINAL          DATETIME,
   @P_CDPAIS           VARCHAR(04),
   @P_SGESTADO         VARCHAR(02),
   @P_NRSEQARQMAG      VARCHAR(10),
   @P_GERAFORSALE      VARCHAR(01),
   @P_CDSITUCRT        VARCHAR(01),
   @P_CONTADOR         NUMERIC      OUTPUT

AS
   DECLARE @V_CONTADOR     NUMERIC;
   DECLARE @V_REGISTRO50   VARCHAR(250);
   DECLARE @V_STTOTAL      VARCHAR(15);
   DECLARE @V_DATA         VARCHAR(15);
   DECLARE @V_CONTREG      NUMERIC;
BEGIN
   SET @V_CONTREG = 0;
   SET @V_CONTADOR  = @P_CONTADOR + 1;

   IF @P_CDSITUCRT = '3' BEGIN    /* QDO A EMPRESA NO  SIMPLES NACIONAL*/
       DECLARE C_REGISTRO50 CURSOR FOR
          SELECT SUBSTRING('50'  +
                 NRINSJUR              +
                 NRINSEST              +
                 RTRIM(DATA)           +
                 SGESTADO              +
                 CDMODDOCFISC          +
                 SERIE                 +
                 NRNOTAFISC            +
                 CDFISCOPERNF          +
                 IDENTRSAIDOP          +
                 VRCONTABILNF          +
                 VRBASECALCNF          +
                 VRIMPOSTONF           +
                 VRISENTRIB            +
                 VROUTCRED             +
                 VRALIQNF              +
                 CANCELADA ,1,126) AS DSARQMAG,DATA


            FROM (SELECT SUBSTRING(RIGHT(REPLICATE('0',14)+ISNULL(CASE CL.IDTPIJURCLIE WHEN 'I' THEN '' WHEN 'O' THEN '' ELSE CL.NRINSJURCLIE END,'00000000000000'),14),1,14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14)AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         LEFT(ISNULL(EC.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF))),'.',''),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF))),'.',''),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF))),'.',''),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB))),'.',''),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED))),'.',''),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF))),'.',''),4)   AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA
                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.CDCLIENTE   = CA.CDCLIENTE AND
                                                              EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P')),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,M.DTFIMPERIODO, M.DTINIPERIODO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END ) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END )  AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END )   AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN (CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END)ELSE  0 END) AS VRISENTRIB
                            FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.CDINSCESTA       = @P_CDINSCESTA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND M.CDIMPOSTO        = @P_CDIMPOSTO
                             AND I.NRSEQUMAPAPU     = M.NRSEQUMAPAPU
                             AND I.CDIMPOSTO        = P.CDIMPOSTO
                             AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                             AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                             AND N.CDFILIAL        = I.CDFILIAL
                             AND N.NRLANCTONF      = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'C'
                             AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '7'
                             AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                 N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO,M.DTFIMPERIODO,CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                                 N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE       = NF.CDCLIENTE
                     AND EC.CDPAIS          = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)
                 UNION ALL






                  SELECT '00000000000000' AS NRINSJUR,
                         'ISENTO        ' AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         'EX' AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END+ REPLICATE (' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)  AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN  'T' ELSE 'P' END AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4)+LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)        AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA

                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P') AND
                                                              EC.CDPAIS       = ISNULL(@P_CDPAIS,EC.CDPAIS)),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF,ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END)  AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END)   AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN CASE I.VRPERREDBCNF WHEN 0 THEN  0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END ELSE 0 END) AS VRISENTRIB
                            FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.CDINSCESTA       = @P_CDINSCESTA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND M.CDIMPOSTO        = @P_CDIMPOSTO
                             AND I.NRSEQUMAPAPU     = M.NRSEQUMAPAPU
                             AND I.CDIMPOSTO        = P.CDIMPOSTO
                             AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                             AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                             AND N.CDFILIAL        = I.CDFILIAL
                             AND N.NRLANCTONF      = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F'ELSE  'C' END ) = 'C'
                             AND SUBSTRING(I.CDFISCOPERNF,1,1) = '7'
                             AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                                    N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE = NF.CDCLIENTE
                     AND EC.CDPAIS    = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO),EC.SGESTADO) > 0)
                 UNION ALL




                  SELECT RIGHT(REPLICATE('0',14)+ISNULL(CASE FO.IDTPIJURFORN WHEN 'I' THEN '' WHEN 'O' THEN ''ELSE FO.NRINSJURFORN END,'00000000000000'),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'S' THEN NF.DTEMISSAO ELSE NF.DTENTRSAID END, 112)AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIEENTR,NF.CDSERIE) WHEN '-' THEN ' 'ELSE REPLACE(ISNULL(NF.CDSERIEENTR,NF.CDSERIE), '-', '') END +REPLICATE(' ',3),3)AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN  'T' ELSE 'P' END AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)        AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA

                    FROM FORNECEDOR FA LEFT JOIN ENDEFORN EF ON (EF.CDFORNECED   = FA.CDFORNECED  AND
                                                                 EF.IDTPENDEFORN = ISNULL(FA.IDENDEMISFOR,'P')),
                         FORNECEDOR FO RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                 N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END) AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END) AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN CASE I.VRPERREDBCNF WHEN 0 THEN  0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END ELSE 0 END) AS VRISENTRIB
                            FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.CDINSCESTA       = @P_CDINSCESTA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND M.CDIMPOSTO        = @P_CDIMPOSTO
                             AND I.NRSEQUMAPAPU     = M.NRSEQUMAPAPU
                             AND I.CDIMPOSTO        = P.CDIMPOSTO
                             AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                             AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                             AND N.CDFILIAL        = I.CDFILIAL
                             AND N.NRLANCTONF      = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'F'
                             AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '3'
                             AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                                    N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (FO.CDFORNECED = NF.CDFORNECED)
                   WHERE FA.CDFORNECED      = NF.CDFORNECED
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL



                  SELECT '00000000000000' AS NRINSJUR,
                         'ISENTO        ' AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'S'THEN NF.DTEMISSAO ELSE NF.DTENTRSAID END,112) AS DATA,
                         'EX' AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIEENTR,NF.CDSERIE) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)     AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA
                   FROM  FORNECEDOR FA LEFT JOIN ENDEFORN EF ON (EF.CDFORNECED   = FA.CDFORNECED AND
                                                                 EF.IDTPENDEFORN = ISNULL(FA.IDENDEMISFOR,'P')),
                         FORNECEDOR FO RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                 N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0  END)  AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END)   AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END ELSE 0 END) AS VRISENTRIB
                           FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                          WHERE M.CDEMPRESA       =  @P_CDEMPRESA
                            AND M.CDINSCESTA      =  @P_CDINSCESTA
                            AND M.DTINIPERIODO    >= @P_DTINICIAL
                            AND M.DTFIMPERIODO    <= @P_DTFINAL
                            AND M.CDIMPOSTO       =  @P_CDIMPOSTO
                            AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                            AND I.CDIMPOSTO        = P.CDIMPOSTO
                            AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                            AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                            AND N.CDFILIAL        = I.CDFILIAL
                            AND N.NRLANCTONF      = I.NRLANCTONF
                            AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F'ELSE 'C' END) = 'F'
                            AND N.IDSTATUS IN ('A','E')
                            AND SUBSTRING(I.CDFISCOPERNF,1,1) = '3'
                            AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                            AND MD.CDTPREGFISC  = '50'
                          GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                   N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                                   N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON(FO.CDFORNECED = NF.CDFORNECED)
                   WHERE FA.CDFORNECED      = NF.CDFORNECED
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL


                  SELECT LEFT(ISNULL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000')+REPLICATE(' ',14),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CASE SUBSTRING(UPPER(FI.CDINSCESTA),1,5) WHEN 'ISENT' THEN 'ISENTO'ELSE FI.CDINSCESTA END, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR, NF.DTENTRSAID,112) AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')END+REPLICATE(' ',3),3)   AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN  'E'THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)       AS VRALIQNF,
                        (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)     AS CANCELADA
                  FROM FILIAL F LEFT JOIN ENDEFILI EF ON (EF.CDFILIAL      = F.CDFILIAL AND
                                                          EF.IDTPENDEFILI  = ISNULL(F.IDENDEMISFIL,'P')),
                       FILIAL FI RIGHT JOIN
                      (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT,
                              N.DTENTRSAID,M.DTINIPERIODO,M.DTFIMPERIODO,
                              CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                              I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                              SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                              SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                              SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0  END)  AS VRIMPOSTONF,
                              SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END)   AS VROUTRCRED,
                              SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END ELSE 0 END) AS VRISENTRIB
                         FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                        WHERE M.CDEMPRESA       = @P_CDEMPRESA
                          AND M.CDINSCESTA      = @P_CDINSCESTA
                          AND M.DTINIPERIODO    >= @P_DTINICIAL
                          AND M.DTFIMPERIODO    <= @P_DTFINAL
                          AND M.CDIMPOSTO       = @P_CDIMPOSTO
                          AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                          AND I.CDIMPOSTO        = P.CDIMPOSTO
                          AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                          AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                          AND N.CDFILIAL        = I.CDFILIAL
                          AND N.NRLANCTONF      = I.NRLANCTONF
                          AND N.IDENTRSAIDOP    = 'E'
                          AND N.IDSTATUS IN ('A','E')
                          AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E'THEN 'F' ELSE 'C' END) = 'L'
                          AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '3'
                          AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                          AND MD.CDTPREGFISC = '50'
                        GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                 N.CDFILIEMIT,N.DTENTRSAID,M.DTINIPERIODO, M.DTFIMPERIODO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,N.CDMODDOCFISC,
                                 N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (FI.CDFILIAL = NF.CDFILIEMIT)
                   WHERE F.CDFILIAL         = NF.CDFILIEMIT
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL
                  SELECT LEFT(ISNULL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000')+REPLICATE(' ',14),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CASE SUBSTRING(UPPER(FI.CDINSCESTA),1,5) WHEN 'ISENT' THEN 'ISENTO'ELSE FI.CDINSCESTA END, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR, NF.DTEMISSAO,112) AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')END+REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN  'E'THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)       AS VRALIQNF,
                        (CASE WHEN NF.DTEMISSAO BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) AS CANCELADA
                    FROM FILIAL F LEFT JOIN ENDEFILI EF ON (EF.IDTPENDEFILI = ISNULL(F.IDENDEMISFIL,'P')AND
                                                             EF.CDPAIS      = ISNULL(@P_CDPAIS,EF.CDPAIS)),
                         FILIAL FI RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF,ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIRECE,
                                 N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END) AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END) AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END ELSE 0 END) AS VRISENTRIB
                            FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO P
                           WHERE M.CDEMPRESA       = @P_CDEMPRESA
                             AND M.CDINSCESTA      = @P_CDINSCESTA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND M.CDIMPOSTO       = @P_CDIMPOSTO
                             AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                             AND I.CDIMPOSTO        = P.CDIMPOSTO
                             AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                             AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                             AND N.CDFILIAL        = I.CDFILIAL
                             AND N.NRLANCTONF      = I.NRLANCTONF
                             AND N.IDENTRSAIDOP    = 'S'
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E'THEN 'F'ELSE 'C' END) = 'L'
                             AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '7'
                             AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.IDENTRSAIDOP,N.CDFILIRECE, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END,
                                    I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF) NF ON (FI.CDFILIAL = NF.CDFILIRECE)
                   WHERE F.CDFILIAL         = NF.CDFILIRECE
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                   /*50 FOS*/
                   UNION ALL
                   SELECT SUBSTRING(RIGHT(REPLICATE('0',14)+ISNULL(CASE CL.IDTPIJURCLIE WHEN 'I' THEN '' WHEN 'O' THEN '' ELSE CL.NRINSJURCLIE END,'00000000000000'),14),1,14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14)AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         LEFT(ISNULL(EC.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF))),'.',''),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF))),'.',''),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF))),'.',''),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB))),'.',''),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED))),'.',''),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF))),'.',''),4)   AS VRALIQNF,
                         'N'
                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.CDCLIENTE   = CA.CDCLIENTE AND
                                                              EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P')),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END ) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END )  AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END )   AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN (CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END)ELSE  0 END) AS VRISENTRIB
                          FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                         WHERE N.CDEMPRESA        = @P_CDEMPRESA
                           AND N.CDINSCESTA       = @P_CDINSCESTA
                           AND I.CDIMPOSTO        = P.CDIMPOSTO
                           AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                           AND N.DTEMISSAO BETWEEN @P_DTINICIAL AND @P_DTFINAL
                           AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                           AND N.CDFILIAL        = I.CDFILIAL
                           AND N.NRLANCTONF      = I.NRLANCTONF
                           AND N.IDENTRSAIDOP  = 'S'
                           AND N.CDMODDOCFISC IN ('01','04','55','06','21','22','2D')
                           AND (N.IDSTATUS IN ('A','E') OR IDSTATUSNFE IN('A','T'))
                           AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'C'
                           AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '7'
                         GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                               N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                               N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE       = NF.CDCLIENTE
                     AND EC.CDPAIS          = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND ISNULL(@P_GERAFORSALE,'N') = 'S'
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)) NF
           ORDER BY DATA;

       OPEN C_REGISTRO50;
       FETCH NEXT FROM C_REGISTRO50 INTO @V_REGISTRO50,@V_DATA;

       WHILE (@@FETCH_STATUS = 0) BEGIN

          INSERT INTO ARQMAGNETICO
             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
             (RIGHT(REPLICATE('0',2)+CONVERT(VARCHAR,@V_CONTADOR),2)+RIGHT(REPLICATE('0',8)+CONVERT(VARCHAR,@V_CONTREG), 8), @V_REGISTRO50, @P_NRSEQARQMAG);

          SET @V_CONTREG  = ISNULL(@V_CONTREG,0) + 1;

       FETCH NEXT FROM C_REGISTRO50 INTO @V_REGISTRO50,@V_DATA;
       END;
       CLOSE C_REGISTRO50;
       DEALLOCATE C_REGISTRO50;
   END;

   IF @P_CDSITUCRT <> '3' BEGIN
       DECLARE C_REGISTRO50 CURSOR FOR
          SELECT SUBSTRING('50'  +
                 NRINSJUR              +
                 NRINSEST              +
                 RTRIM(DATA)           +
                 SGESTADO              +
                 CDMODDOCFISC          +
                 SERIE                 +
                 NRNOTAFISC            +
                 CDFISCOPERNF          +
                 IDENTRSAIDOP          +
                 VRCONTABILNF          +
                 VRBASECALCNF          +
                 VRIMPOSTONF           +
                 VRISENTRIB            +
                 VROUTCRED             +
                 VRALIQNF              +
                 CANCELADA ,1,126) AS DSARQMAG,DATA


            FROM (SELECT SUBSTRING(RIGHT(REPLICATE('0',14)+ISNULL(CASE CL.IDTPIJURCLIE WHEN 'I' THEN '' WHEN 'O' THEN '' ELSE CL.NRINSJURCLIE END,'00000000000000'),14),1,14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14)AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         LEFT(ISNULL(EC.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF))),'.',''),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF))),'.',''),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF))),'.',''),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB))),'.',''),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED))),'.',''),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF))),'.',''),4)   AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA
                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.CDCLIENTE   = CA.CDCLIENTE AND
                                                              EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P')),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,M.DTFIMPERIODO, M.DTINIPERIODO,
                                 0 AS VRALIQNF,
                                 I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTITEM) AS VRCONTABILNF,
                                 0 AS VRBASECALCNF,
                                 0 AS VRIMPOSTONF,
                                 SUM(I.VRCONTITEM) AS VROUTRCRED,
                                 0 AS VRISENTRIB
                            FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND N.CDINSCESTA       = @P_CDINSCESTA
                             AND M.NRSEQUMAPAPU     = N.NRSEQUMAPAPUSN
                             AND N.CDFILIAL         = I.CDFILIAL
                             AND N.NRLANCTONF       = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'C'
                             AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                 N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO,M.DTFIMPERIODO, I.CDFISOPEITEM,
                                 N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE       = NF.CDCLIENTE
                     AND EC.CDPAIS          = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)
                 UNION ALL






                  SELECT '00000000000000' AS NRINSJUR,
                         'ISENTO        ' AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         'EX' AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END+ REPLICATE (' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)  AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN  'T' ELSE 'P' END AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4)+LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)        AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA

                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P') AND
                                                              EC.CDPAIS       = ISNULL(@P_CDPAIS,EC.CDPAIS)),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF,ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 0 AS VRALIQNF,
                                 I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTITEM) AS VRCONTABILNF,
                                 0 AS VRBASECALCNF,
                                 0 AS VRIMPOSTONF,
                                 SUM(I.VRCONTITEM) AS VROUTRCRED,
                                 0 AS VRISENTRIB
                            FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND N.CDINSCESTA       = @P_CDINSCESTA
                             AND M.NRSEQUMAPAPU     = N.NRSEQUMAPAPUSN
                             AND N.CDFILIAL         = I.CDFILIAL
                             AND N.NRLANCTONF       = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F'ELSE  'C' END ) = 'C'
                             AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, I.CDFISOPEITEM,
                                    N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE = NF.CDCLIENTE
                     AND EC.CDPAIS    = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO),EC.SGESTADO) > 0)
                 UNION ALL




                  SELECT RIGHT(REPLICATE('0',14)+ISNULL(CASE FO.IDTPIJURFORN WHEN 'I' THEN '' WHEN 'O' THEN ''ELSE FO.NRINSJURFORN END,'00000000000000'),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'S' THEN NF.DTEMISSAO ELSE NF.DTENTRSAID END, 112)AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIEENTR,NF.CDSERIE) WHEN '-' THEN ' 'ELSE REPLACE(ISNULL(NF.CDSERIEENTR,NF.CDSERIE), '-', '') END +REPLICATE(' ',3),3)AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN  'T' ELSE 'P' END AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)        AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA

                    FROM FORNECEDOR FA LEFT JOIN ENDEFORN EF ON (EF.CDFORNECED   = FA.CDFORNECED  AND
                                                                 EF.IDTPENDEFORN = ISNULL(FA.IDENDEMISFOR,'P')),
                         FORNECEDOR FO RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                 N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 0 AS VRALIQNF,
                                 I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTITEM) AS VRCONTABILNF,
                                 0 AS VRBASECALCNF,
                                 0 AS VRIMPOSTONF,
                                 SUM(I.VRCONTITEM) AS VROUTRCRED,
                                 0 AS VRISENTRIB
                            FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                           WHERE M.CDEMPRESA        = @P_CDEMPRESA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND N.CDINSCESTA       = @P_CDINSCESTA
                             AND N.NRSEQUMAPAPUSN   = M.NRSEQUMAPAPU
                             AND N.CDFILIAL         = I.CDFILIAL
                             AND N.NRLANCTONF       = I.NRLANCTONF
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'F'
                             AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC  = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, I.CDFISOPEITEM,
                                    N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (FO.CDFORNECED = NF.CDFORNECED)
                   WHERE FA.CDFORNECED      = NF.CDFORNECED
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL



                  SELECT '00000000000000' AS NRINSJUR,
                         'ISENTO        ' AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'S'THEN NF.DTEMISSAO ELSE NF.DTENTRSAID END,112) AS DATA,
                         'EX' AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIEENTR,NF.CDSERIE) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)     AS VRALIQNF,
                         (CASE NF.IDENTRSAIDOP WHEN 'S' THEN (CASE WHEN NF.DTEMISSAO  BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)
                                                        ELSE (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) END) AS CANCELADA
                   FROM  FORNECEDOR FA LEFT JOIN ENDEFORN EF ON (EF.CDFORNECED   = FA.CDFORNECED AND
                                                                 EF.IDTPENDEFORN = ISNULL(FA.IDENDEMISFOR,'P')),
                         FORNECEDOR FO RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                 N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 0 AS VRALIQNF,
                                 I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTITEM) AS VRCONTABILNF,
                                 0 AS VRBASECALCNF,
                                 0 AS VRIMPOSTONF,
                                 SUM(I.VRCONTITEM) AS VROUTRCRED,
                                 0 AS VRISENTRIB
                           FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                          WHERE M.CDEMPRESA       =  @P_CDEMPRESA
                            AND M.DTINIPERIODO    >= @P_DTINICIAL
                            AND M.DTFIMPERIODO    <= @P_DTFINAL
                            AND N.CDINSCESTA      =  @P_CDINSCESTA
                            AND N.NRSEQUMAPAPUSN  = M.NRSEQUMAPAPU
                            AND N.CDFILIAL        = I.CDFILIAL
                            AND N.NRLANCTONF      = I.NRLANCTONF
                            AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F'ELSE 'C' END) = 'F'
                            AND N.IDSTATUS IN ('A','E')
                            AND N.CDMODDOCFISC  = MD.CDMODDOCFISC
                            AND MD.CDTPREGFISC  = '50'
                          GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                   N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO, I.CDFISOPEITEM,
                                   N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON(FO.CDFORNECED = NF.CDFORNECED)
                   WHERE FA.CDFORNECED      = NF.CDFORNECED
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL


                  SELECT LEFT(ISNULL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000')+REPLICATE(' ',14),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CASE SUBSTRING(UPPER(FI.CDINSCESTA),1,5) WHEN 'ISENT' THEN 'ISENTO'ELSE FI.CDINSCESTA END, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR, NF.DTENTRSAID,112) AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')END+REPLICATE(' ',3),3)   AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN  'E'THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)       AS VRALIQNF,
                        (CASE WHEN NF.DTENTRSAID BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END)     AS CANCELADA
                  FROM FILIAL F LEFT JOIN ENDEFILI EF ON (EF.CDFILIAL      = F.CDFILIAL AND
                                                          EF.IDTPENDEFILI  = ISNULL(F.IDENDEMISFIL,'P')),
                       FILIAL FI RIGHT JOIN
                      (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT,
                              N.DTENTRSAID,M.DTINIPERIODO,M.DTFIMPERIODO,
                               0 AS VRALIQNF,
                               I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                               SUM(I.VRCONTITEM) AS VRCONTABILNF,
                               0 AS VRBASECALCNF,
                               0 AS VRIMPOSTONF,
                               SUM(I.VRCONTITEM) AS VROUTRCRED,
                               0 AS VRISENTRIB
                         FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                        WHERE M.CDEMPRESA       = @P_CDEMPRESA
                          AND M.DTINIPERIODO    >= @P_DTINICIAL
                          AND M.DTFIMPERIODO    <= @P_DTFINAL
                          AND N.CDINSCESTA      = @P_CDINSCESTA
                          AND N.NRSEQUMAPAPUSN  = M.NRSEQUMAPAPU
                          AND N.CDFILIAL        = I.CDFILIAL
                          AND N.NRLANCTONF      = I.NRLANCTONF
                          AND N.IDENTRSAIDOP    = 'E'
                          AND N.IDSTATUS IN ('A','E')
                          AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E'THEN 'F' ELSE 'C' END) = 'L'
                          AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                          AND MD.CDTPREGFISC = '50'
                        GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                 N.CDFILIEMIT,N.DTENTRSAID,M.DTINIPERIODO, M.DTFIMPERIODO, I.CDFISOPEITEM, N.CDMODDOCFISC,
                                 N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (FI.CDFILIAL = NF.CDFILIEMIT)
                   WHERE F.CDFILIAL         = NF.CDFILIEMIT
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                 UNION ALL
                  SELECT LEFT(ISNULL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000')+REPLICATE(' ',14),14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CASE SUBSTRING(UPPER(FI.CDINSCESTA),1,5) WHEN 'ISENT' THEN 'ISENTO'ELSE FI.CDINSCESTA END, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14) AS NRINSEST,
                         CONVERT(CHAR, NF.DTEMISSAO,112) AS DATA,
                         LEFT(ISNULL(EF.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')END+REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6)AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN  'E'THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF)),'.','')),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF)),'.','')),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF)),'.','')),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB)),'.','')),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+LTRIM(REPLACE(CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED)),'.','')),13)   AS VROUTRCRED,
                         RIGHT(REPLICATE('0',4) +LTRIM(REPLACE(CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF)),'.','')),4)       AS VRALIQNF,
                        (CASE WHEN NF.DTEMISSAO BETWEEN NF.DTINIPERIODO AND NF.DTFIMPERIODO THEN 'N' ELSE 'E' END) AS CANCELADA
                    FROM FILIAL F LEFT JOIN ENDEFILI EF ON (EF.IDTPENDEFILI = ISNULL(F.IDENDEMISFIL,'P')AND
                                                             EF.CDPAIS      = ISNULL(@P_CDPAIS,EF.CDPAIS)),
                         FILIAL FI RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF,ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIRECE,
                                 N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                 0 AS VRALIQNF,
                                 I.CDFISOPEITEM AS CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTITEM) AS VRCONTABILNF,
                                 0 AS VRBASECALCNF,
                                 0 AS VRIMPOSTONF,
                                 SUM(I.VRCONTITEM) AS VROUTRCRED,
                                 0 AS VRISENTRIB
                            FROM MAPAAPURACSN M, NOTAFISCAL N, ITEMPRODUTO I, MODDOCFISC MD
                           WHERE M.CDEMPRESA       = @P_CDEMPRESA
                             AND M.DTINIPERIODO    >= @P_DTINICIAL
                             AND M.DTFIMPERIODO    <= @P_DTFINAL
                             AND N.CDINSCESTA      = @P_CDINSCESTA
                             AND N.NRSEQUMAPAPUSN   = M.NRSEQUMAPAPU
                             AND N.CDFILIAL        = I.CDFILIAL
                             AND N.NRLANCTONF      = I.NRLANCTONF
                             AND N.IDENTRSAIDOP    = 'S'
                             AND N.IDSTATUS IN ('A','E')
                             AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E'THEN 'F'ELSE 'C' END) = 'L'
                             AND N.CDMODDOCFISC = MD.CDMODDOCFISC
                             AND MD.CDTPREGFISC = '50'
                           GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                                    N.IDENTRSAIDOP,N.CDFILIRECE, N.DTEMISSAO,M.DTINIPERIODO, M.DTFIMPERIODO,
                                    I.CDFISOPEITEM, N.CDMODDOCFISC, N.IDORIGDESTNF) NF ON (FI.CDFILIAL = NF.CDFILIRECE)
                   WHERE F.CDFILIAL         = NF.CDFILIRECE
                     AND EF.CDPAIS          = ISNULL(@P_CDPAIS,EF.CDPAIS)
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                   /*50 FOS*/
                   UNION ALL
                   SELECT SUBSTRING(RIGHT(REPLICATE('0',14)+ISNULL(CASE CL.IDTPIJURCLIE WHEN 'I' THEN '' WHEN 'O' THEN '' ELSE CL.NRINSJURCLIE END,'00000000000000'),14),1,14) AS NRINSJUR,
                         LEFT(ISNULL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO')+REPLICATE(' ',14),14)AS NRINSEST,
                         CONVERT(CHAR,CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.DTENTRSAID ELSE NF.DTEMISSAO END,112) AS DATA,
                         LEFT(ISNULL(EC.SGESTADO,' ')+REPLICATE(' ',2),2) AS SGESTADO,
                         LEFT(ISNULL(NF.CDMODDOCFISC,'01')+REPLICATE(' ',2),2) AS CDMODDOCFISC,
                         LEFT(CASE ISNULL(NF.CDSERIE,NF.CDSERIEENTR) WHEN '-' THEN ' ' ELSE REPLACE(ISNULL(NF.CDSERIE,NF.CDSERIEENTR), '-', '') END + REPLICATE(' ',3),3) AS SERIE,
                         RIGHT(REPLICATE('0',6)+SUBSTRING(NF.NRNOTAFISC,LEN(NF.NRNOTAFISC)-5,6),6) AS NRNOTAFISC,
                         LEFT(ISNULL(NF.CDFISCOPERNF,'0')+REPLICATE(' ',4),4) AS CDFISCOPERNF,
                         CASE NF.IDENTRSAIDOP WHEN 'E' THEN 'T' ELSE 'P' END  AS IDENTRSAIDOP,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRCONTABILNF))),'.',''),13) AS VRCONTABILNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRBASECALCNF))),'.',''),13) AS VRBASECALCNF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRIMPOSTONF))),'.',''),13)  AS VRIMPOSTONF,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VRISENTRIB))),'.',''),13)   AS VRISENTRIB,
                         RIGHT(REPLICATE('0',13)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(13,2),ABS(NF.VROUTRCRED))),'.',''),13)   AS VROUTCRED,
                         RIGHT(REPLICATE('0',4)+REPLACE(CONVERT(VARCHAR,CONVERT(NUMERIC(4,2),ABS(NF.VRALIQNF))),'.',''),4)   AS VRALIQNF,
                         'N'
                    FROM CLIENTE CA LEFT JOIN ENDECLIE EC ON (EC.CDCLIENTE   = CA.CDCLIENTE AND
                                                              EC.IDTPENDECLIE = ISNULL(CA.IDENDEMISCLI,'P')),
                         CLIENTE CL RIGHT JOIN
                         (SELECT I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0') AS NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                 N.DTEMISSAO,
                                 CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END AS VRALIQNF,
                                 I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END ) AS VRBASECALCNF,
                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRIMPOSTONF  ELSE 0 END )  AS VRIMPOSTONF,
                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN I.VRCONTABILNF ELSE 0 END )   AS VROUTRCRED,
                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF WHEN '1' THEN (CASE I.VRPERREDBCNF WHEN 0 THEN 0 ELSE I.VRCONTABILNF-I.VRBASECALCNF END)ELSE  0 END) AS VRISENTRIB
                          FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                         WHERE N.CDEMPRESA        = @P_CDEMPRESA
                           AND N.CDINSCESTA       = @P_CDINSCESTA
                           AND I.CDIMPOSTO        = P.CDIMPOSTO
                           AND P.CDIMPOSTONFE     = @P_CDIMPOSTO
                           AND N.DTEMISSAO BETWEEN @P_DTINICIAL AND @P_DTFINAL
                           AND ISNULL(I.IDIMPOSTONF, '1') <> '3'
                           AND N.CDFILIAL        = I.CDFILIAL
                           AND N.NRLANCTONF      = I.NRLANCTONF
                           AND N.IDENTRSAIDOP  = 'S'
                           AND N.CDMODDOCFISC IN ('01','04','55','06','21','22','2D')
                           AND (N.IDSTATUS IN ('A','E') OR IDSTATUSNFE IN('A','T'))
                           AND ISNULL(N.IDORIGDESTNF, CASE N.IDENTRSAIDOP WHEN 'E' THEN 'F' ELSE 'C' END) = 'C'
                           AND ISNULL(SUBSTRING(I.CDFISCOPERNF,1,1),' ') <> '7'
                         GROUP BY I.CDFILIAL, I.NRLANCTONF, ISNULL(N.NRNOTAFISC,'0'), N.CDSERIE, N.CDSERIEENTR,
                               N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO, CASE I.CDFISCALNF WHEN '1' THEN I.VRALIQNF ELSE 0 END, I.CDFISCOPERNF,
                               N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF ON (CL.CDCLIENTE = NF.CDCLIENTE)
                   WHERE CA.CDCLIENTE       = NF.CDCLIENTE
                     AND EC.CDPAIS          = ISNULL(@P_CDPAIS,EC.CDPAIS)
                     AND ISNULL(@P_GERAFORSALE,'N') = 'S'
                     AND (CHARINDEX(ISNULL(@P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)) NF
           ORDER BY DATA;

       OPEN C_REGISTRO50;
       FETCH NEXT FROM C_REGISTRO50 INTO @V_REGISTRO50,@V_DATA;

       WHILE (@@FETCH_STATUS = 0) BEGIN

          INSERT INTO ARQMAGNETICO
             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
             (RIGHT(REPLICATE('0',2)+CONVERT(VARCHAR,@V_CONTADOR),2)+RIGHT(REPLICATE('0',8)+CONVERT(VARCHAR,@V_CONTREG), 8), @V_REGISTRO50, @P_NRSEQARQMAG);

          SET @V_CONTREG  = ISNULL(@V_CONTREG,0) + 1;

       FETCH NEXT FROM C_REGISTRO50 INTO @V_REGISTRO50,@V_DATA;
       END;
       CLOSE C_REGISTRO50;
       DEALLOCATE C_REGISTRO50;
   END;

   SET @P_CONTADOR = @V_CONTADOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ARQUIVO_SINTEGRA_50','5.30.000';
GO

